create table input.input_transactions
(
    transaction_id uuid not null primary key,
    bank_transaction_id text not null,
    transaction_timestamp timestamp not null,
    created_at    timestamp not null,
    originating_bank_bic text not null,
    counterparty_bank_bic text not null,
    originator_iban text not null,
    counterparty_iban text not null,
    amount float not null,
    currency text not null,
    transaction_type text not null
);

comment on column input.input_transactions.transaction_id is 'UUID generated by safeAML';

comment on column input.input_transactions.bank_transaction_id is 'the ID of the transaction in the bank system';

comment on column input.input_transactions.transaction_timestamp is 'the timestamp when the transaction occured';

comment on column input.input_transactions.created_at is 'the timestamp when the record was created';

comment on column input.input_transactions.originating_bank_bic is 'the BIC of the account holding party';

comment on column input.input_transactions.counterparty_bank_bic is 'the BIC of the counterparty';

comment on column input.input_transactions.originator_iban is 'the IBAN of the originator party';

comment on column input.input_transactions.counterparty_iban is 'the IBAN of the counterparty';

comment on column input.input_transactions.amount is 'the transaction amount';

comment on column input.input_transactions.currency is 'the currency in which the transaction occurs';

comment on column input.input_transactions.transaction_type is 'the transaction type of this transaction';

create table intermediate.intermediate_transactions
(
    transaction_id uuid not null primary key,
    bank_transaction_id text,
    created_at    timestamp not null,
    originator_bank_bic text not null,
    beneficiary_bank_bic text not null,
    originator_iban text not null,
    beneficiary_iban text not null,
    amount float not null,
    currency text not null,
    transaction_type text not null
);

comment on column intermediate.intermediate_transactions.transaction_id is 'UUID generated by safeAML';

comment on column intermediate.intermediate_transactions.bank_transaction_id is 'the ID of the transaction in the bank system. can be null if this information would not be available for the bank for which we return this information';

comment on column intermediate.intermediate_transactions.originator_bank_bic is 'the BIC of the account holding party';

comment on column intermediate.intermediate_transactions.beneficiary_bank_bic is 'the BIC of the counterparty';

comment on column intermediate.intermediate_transactions.originator_iban is 'the IBAN of the originator party.';

comment on column intermediate.intermediate_transactions.beneficiary_iban is 'the IBAN of the counterparty.';

comment on column intermediate.intermediate_transactions.amount is 'the transaction amount';

comment on column intermediate.intermediate_transactions.currency is 'the currency in which the transaction occurs';

comment on column intermediate.intermediate_transactions.transaction_type is 'the transaction type of this transaction';

create table output.output_transactions
(
    transaction_id uuid not null,
    bank_transaction_id text,
    transaction_timestamp timestamp not null,
    created_at    timestamp not null default NOW(),
    originating_bank_bic text not null,
    counterparty_bank_bic text not null,
    originator_iban text,
    counterparty_iban text,
    amount float not null,
    currency text not null,
    transaction_type text not null,
    security_column text not null,
    CONSTRAINT primary_key_output PRIMARY KEY (transaction_id, security_column)
);

ALTER TABLE output.output_transactions ENABLE ROW LEVEL SECURITY;

comment on column output.output_transactions.transaction_id is 'UUID generated by safeAML';

comment on column output.output_transactions.bank_transaction_id is 'the ID of the transaction in the bank system. can be null if this information would not be available for the bank for which we return this information';

comment on column output.output_transactions.transaction_timestamp is 'the timestamp when the transaction occured';

comment on column output.output_transactions.created_at is 'the timestamp when the record was created';

comment on column output.output_transactions.originating_bank_bic is 'the BIC of the account holding party';

comment on column output.output_transactions.counterparty_bank_bic is 'the BIC of the counterparty';

comment on column output.output_transactions.originator_iban is 'the IBAN of the originator party. can be null if this information would not be available for the bank for which we return this information';

comment on column output.output_transactions.counterparty_iban is 'the IBAN of the counterparty. can be null if this information would not be available for the bank for which we return this information';

comment on column output.output_transactions.amount is 'the transaction amount';

comment on column output.output_transactions.currency is 'the currency in which the transaction occurs';

comment on column output.output_transactions.transaction_type is 'the transaction type of this transaction';
